/*
 *  Name        : kcmjoy.cpp ( part of kcmjoy )
 *  Version     : 0.1
 *  Description : Joystick setup utility for KDE
 *
 *  Copyright (C) 1998 Luca Montecchiani <m.luca@usa.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#define kcmjoy_included
#include "kcmjoy.h"
#include "kcmjoy.moc"

static bool GUI;

Kcmjoy::Kcmjoy( QWidget *parent, const char *name , bool init)
        : KConfigWidget (parent, name)     
{
	initMetaObject();

	// First of all some cleaunp.....
	CleanupVar(TRUE);

	if (init)
		{
		GUI = FALSE;
		return;
		}
	else	GUI = TRUE;  

	// *************************************************************
	// Start Dialog
	// *************************************************************

	QFrame* dlgedit_Frame_27;
	dlgedit_Frame_27 = new QFrame( this, "Frame_27" );
	dlgedit_Frame_27->setGeometry( 315, 140, 75, 45 );
	dlgedit_Frame_27->setMinimumSize( 10, 10 );
	dlgedit_Frame_27->setMaximumSize( 32767, 32767 );
	dlgedit_Frame_27->setFrameStyle( 49 );

	QFrame* dlgedit_Frame_18;
	dlgedit_Frame_18 = new QFrame( this, "Frame_18" );
	dlgedit_Frame_18->setGeometry( 170, 10, 220, 125 );
	dlgedit_Frame_18->setMinimumSize( 10, 10 );
	dlgedit_Frame_18->setMaximumSize( 32767, 32767 );
	dlgedit_Frame_18->setFrameStyle( 49 );

	QFrame* dlgedit_Frame_17;
	dlgedit_Frame_17 = new QFrame( this, "Frame_17" );
	dlgedit_Frame_17->setGeometry( 10, 225, 380, 60 );
	dlgedit_Frame_17->setMinimumSize( 10, 10 );
	dlgedit_Frame_17->setMaximumSize( 32767, 32767 );
	dlgedit_Frame_17->setFrameStyle( 49 );

	QFrame* dlgedit_Frame_4;
	dlgedit_Frame_4 = new QFrame( this, "Frame_4" );
	dlgedit_Frame_4->setGeometry( 10, 10, 155, 125 );
	dlgedit_Frame_4->setMinimumSize( 10, 10 );
	dlgedit_Frame_4->setMaximumSize( 32767, 32767 );
	dlgedit_Frame_4->setFrameStyle( 49 );

	QFrame* dlgedit_Frame_9;
	dlgedit_Frame_9 = new QFrame( this, "Frame_9" );
	dlgedit_Frame_9->setGeometry( 10, 140, 300, 45 );
	dlgedit_Frame_9->setMinimumSize( 10, 10 );
	dlgedit_Frame_9->setMaximumSize( 32767, 32767 );
	dlgedit_Frame_9->setFrameStyle( 49 );

	Display = new QFrame( this, "Frame_1" );
	Display->setGeometry( 20, 20, 70, 70 );
	Display->setMinimumSize( 70, 70 );
	Display->setMaximumSize( 70, 70 );
	{
		QColorGroup normal( QColor( QRgb(0) ), QColor( QRgb(16777215) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(0) ) );
		QColorGroup disabled( QColor( QRgb(8421504) ), QColor( QRgb(12632256) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(8421504) ), QColor( QRgb(12632256) ) );
		QColorGroup active( QColor( QRgb(0) ), QColor( QRgb(12632256) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
		QPalette palette( normal, disabled, active );
		Display->setPalette( palette );
	}
	Display->setMidLineWidth( 1 );

	Devices = new QComboBox( FALSE, this, "ComboBox_1" );
	Devices->setGeometry( 15, 235, 235, 20 );
	Devices->setMinimumSize( 10, 10 );
	Devices->setMaximumSize( 32767, 32767 );
	connect( Devices, SIGNAL(activated(int)), SLOT(ChangeDevice(int)) );
	Devices->setSizeLimit( 10 );
	Devices->setAutoResize( FALSE );

	QLabel* dlgedit_Label_3;
	dlgedit_Label_3 = new QLabel( this, "Label_3" );
	dlgedit_Label_3->setGeometry( 180, 40, 80, 20 );
	dlgedit_Label_3->setMinimumSize( 10, 10 );
	dlgedit_Label_3->setMaximumSize( 32767, 32767 );
	dlgedit_Label_3->setText( ktr("X precision") );
	dlgedit_Label_3->setAlignment( 289 );
	dlgedit_Label_3->setMargin( -1 );

	QLabel* dlgedit_Label_6;
	dlgedit_Label_6 = new QLabel( this, "Label_6" );
	dlgedit_Label_6->setGeometry( 180, 100, 80, 20 );
	dlgedit_Label_6->setMinimumSize( 10, 10 );
	dlgedit_Label_6->setMaximumSize( 32767, 32767 );
	dlgedit_Label_6->setText( ktr("Read speed") );
	dlgedit_Label_6->setAlignment( 289 );
	dlgedit_Label_6->setMargin( -1 );

	QLabel* dlgedit_Label_7;
	dlgedit_Label_7 = new QLabel( this, "Label_7" );
	dlgedit_Label_7->setGeometry( 180, 70, 80, 20 );
	dlgedit_Label_7->setMinimumSize( 10, 10 );
	dlgedit_Label_7->setMaximumSize( 32767, 32767 );
	dlgedit_Label_7->setText( ktr("Y precision") );
	dlgedit_Label_7->setAlignment( 289 );
	dlgedit_Label_7->setMargin( -1 );

	But1 = new QFrame( this, "But_1" );
	But1->setGeometry( 70, 170, 50, 10 );
	But1->setMinimumSize( 10, 10 );
	But1->setMaximumSize( 32767, 32767 );
	{
		QColorGroup normal( QColor( QRgb(128) ), QColor( QRgb(128) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
		QColorGroup disabled( QColor( QRgb(255) ), QColor( QRgb(255) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(8421504) ), QColor( QRgb(12632256) ) );
		QColorGroup active( QColor( QRgb(128) ), QColor( QRgb(128) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
		QPalette palette( normal, disabled, active );
		But1->setPalette( palette );
	}
	But1->setFrameStyle( 50 );
	But1->setLineWidth( 2 );
	But1->setMidLineWidth( 2 );

	QLabel* dlgedit_Label_9;
	dlgedit_Label_9 = new QLabel( this, "Label_9" );
	dlgedit_Label_9->setGeometry( 70, 150, 50, 10 );
	dlgedit_Label_9->setMinimumSize( 10, 10 );
	dlgedit_Label_9->setMaximumSize( 32767, 32767 );
	dlgedit_Label_9->setText( ktr("Button 1") );
	dlgedit_Label_9->setAlignment( 289 );
	dlgedit_Label_9->setMargin( -1 );

	QLabel* dlgedit_Label_10;
	dlgedit_Label_10 = new QLabel( this, "Label_10" );
	dlgedit_Label_10->setGeometry( 130, 150, 50, 10 );
	dlgedit_Label_10->setMinimumSize( 10, 10 );
	dlgedit_Label_10->setMaximumSize( 32767, 32767 );
	dlgedit_Label_10->setText( ktr("Button 2") );
	dlgedit_Label_10->setAlignment( 289 );
	dlgedit_Label_10->setMargin( -1 );

	But2 = new QFrame( this, "But_2" );
	But2->setGeometry( 130, 170, 50, 10 );
	But2->setMinimumSize( 10, 10 );
	But2->setMaximumSize( 32767, 32767 );
	{
		QColorGroup normal( QColor( QRgb(128) ), QColor( QRgb(128) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
		QColorGroup disabled( QColor( QRgb(255) ), QColor( QRgb(255) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(8421504) ), QColor( QRgb(12632256) ) );
		QColorGroup active( QColor( QRgb(128) ), QColor( QRgb(128) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
		QPalette palette( normal, disabled, active );
		But2->setPalette( palette );
	}
	But2->setFrameStyle( 50 );
	But2->setLineWidth( 2 );
	But2->setMidLineWidth( 2 );

	QLabel* dlgedit_Label_11;
	dlgedit_Label_11 = new QLabel( this, "Label_11" );
	dlgedit_Label_11->setGeometry( 190, 150, 50, 10 );
	dlgedit_Label_11->setMinimumSize( 10, 10 );
	dlgedit_Label_11->setMaximumSize( 32767, 32767 );
	dlgedit_Label_11->setText( ktr("Button 3") );
	dlgedit_Label_11->setAlignment( 289 );
	dlgedit_Label_11->setMargin( -1 );

	But3 = new QFrame( this, "But_3" );
	But3->setGeometry( 190, 170, 50, 10 );
	But3->setMinimumSize( 10, 10 );
	But3->setMaximumSize( 32767, 32767 );
	{
		QColorGroup normal( QColor( QRgb(128) ), QColor( QRgb(128) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
		QColorGroup disabled( QColor( QRgb(255) ), QColor( QRgb(255) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(8421504) ), QColor( QRgb(12632256) ) );
		QColorGroup active( QColor( QRgb(128) ), QColor( QRgb(128) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
		QPalette palette( normal, disabled, active );
		But3->setPalette( palette );
	}
	But3->setFrameStyle( 50 );
	But3->setLineWidth( 2 );
	But3->setMidLineWidth( 2 );

	QLabel* dlgedit_Label_12;
	dlgedit_Label_12 = new QLabel( this, "Label_12" );
	dlgedit_Label_12->setGeometry( 250, 150, 50, 10 );
	dlgedit_Label_12->setMinimumSize( 10, 10 );
	dlgedit_Label_12->setMaximumSize( 32767, 32767 );
	dlgedit_Label_12->setText( ktr("Button 4") );
	dlgedit_Label_12->setAlignment( 289 );
	dlgedit_Label_12->setMargin( -1 );

	But4 = new QFrame( this, "But_4" );
	But4->setGeometry( 250, 170, 50, 10 );
	But4->setMinimumSize( 10, 10 );
	But4->setMaximumSize( 32767, 32767 );
	{
		QColorGroup normal( QColor( QRgb(128) ), QColor( QRgb(128) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
		QColorGroup disabled( QColor( QRgb(255) ), QColor( QRgb(255) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(8421504) ), QColor( QRgb(12632256) ) );
		QColorGroup active( QColor( QRgb(128) ), QColor( QRgb(128) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
		QPalette palette( normal, disabled, active );
		But4->setPalette( palette );
	}
	But4->setFrameStyle( 50 );
	But4->setLineWidth( 2 );
	But4->setMidLineWidth( 2 );

	QLabel* dlgedit_Label_13;
	dlgedit_Label_13 = new QLabel( this, "Label_13" );
	dlgedit_Label_13->setGeometry( 20, 110, 50, 20 );
	dlgedit_Label_13->setMinimumSize( 10, 10 );
	dlgedit_Label_13->setMaximumSize( 32767, 32767 );
	dlgedit_Label_13->setText( ktr("Y range:") );
	dlgedit_Label_13->setAlignment( 289 );
	dlgedit_Label_13->setMargin( -1 );

	QLabel* dlgedit_Label_14;
	dlgedit_Label_14 = new QLabel( this, "Label_14" );
	dlgedit_Label_14->setGeometry( 20, 90, 50, 20 );
	dlgedit_Label_14->setMinimumSize( 10, 10 );
	dlgedit_Label_14->setMaximumSize( 32767, 32767 );
	dlgedit_Label_14->setText( ktr("X range:") );
	dlgedit_Label_14->setAlignment( 289 );
	dlgedit_Label_14->setMargin( -1 );

	yrange = new QLabel( this, "Yrange_lb" );
	yrange->setGeometry( 70, 110, 80, 20 );
	yrange->setMinimumSize( 10, 10 );
	yrange->setMaximumSize( 32767, 32767 );
	yrange->setText( "" );
	yrange->setAlignment( 289 );
	yrange->setMargin( -1 );

	xrange = new QLabel( this, "Xrange_lb" );
	xrange->setGeometry( 70, 90, 80, 20 );
	xrange->setMinimumSize( 10, 10 );
	xrange->setMaximumSize( 32767, 32767 );
	xrange->setText( "" );
	xrange->setAlignment( 289 );
	xrange->setMargin( -1 );

	QPushButton* dlgedit_PushButton_8;
	dlgedit_PushButton_8 = new QPushButton( this, "PushButton_8" );
	dlgedit_PushButton_8->setGeometry( 260, 235, 120, 20 );
	dlgedit_PushButton_8->setMinimumSize( 10, 10 );
	dlgedit_PushButton_8->setMaximumSize( 32767, 32767 );
	connect( dlgedit_PushButton_8, SIGNAL(clicked()), SLOT(Insmod()) );
	dlgedit_PushButton_8->setText( ktr("&Load driver") );
	dlgedit_PushButton_8->setAutoRepeat( FALSE );
	dlgedit_PushButton_8->setAutoResize( FALSE );

	icona1 = new QLabel( this, "Label_17" );
	icona1->setGeometry( 110, 35, 35, 35 );
	icona1->setMinimumSize( 10, 10 );
	icona1->setMaximumSize( 32767, 32767 );
	icona1->setText( "" );
	icona1->setAlignment( 289 );
	icona1->setMargin( -1 );

	icona2 = new QLabel( this, "Label_18" );
	icona2->setGeometry( 20, 145, 40, 35 );
	icona2->setMinimumSize( 10, 10 );
	icona2->setMaximumSize( 32767, 32767 );
	icona2->setText( "" );
	icona2->setAlignment( 289 );
	icona2->setMargin( -1 );        

	QPushButton* dlgedit_PushButton_10;
	dlgedit_PushButton_10 = new QPushButton( this, "PushButton_10" );
	dlgedit_PushButton_10->setGeometry( 325, 150, 55, 25 );
	dlgedit_PushButton_10->setMinimumSize( 10, 10 );
	dlgedit_PushButton_10->setMaximumSize( 32767, 32767 );
	connect( dlgedit_PushButton_10, SIGNAL(clicked()), SLOT(About()) );
	dlgedit_PushButton_10->setText( ktr("&About") );
	dlgedit_PushButton_10->setAutoRepeat( FALSE );
	dlgedit_PushButton_10->setAutoResize( FALSE );

	xslider = new QSlider( this, "Slider_1" );
	xslider->setGeometry( 260, 40, 120, 20 );
	xslider->setMinimumSize( 120, 20 );
	xslider->setMaximumSize( 120, 20 );
	connect( xslider, SIGNAL(valueChanged(int)), SLOT(xchange(int)) );
	xslider->setOrientation( QSlider::Horizontal );
	xslider->setRange( 0, 4 );
	xslider->setSteps( 1, 0 );
	xslider->setValue( 0 );
	xslider->setTracking( FALSE );
	xslider->setTickmarks( QSlider::Above );
	xslider->setTickInterval( 1 );

	yslider = new QSlider( this, "Slider_2" );
	yslider->setGeometry( 260, 70, 120, 20 );
	yslider->setMinimumSize( 10, 10 );
	yslider->setMaximumSize( 32767, 32767 );
	connect( yslider, SIGNAL(valueChanged(int)), SLOT(ychange(int)) );
	yslider->setOrientation( QSlider::Horizontal );
	yslider->setRange( 0, 4 );
	yslider->setSteps( 1, 0 );
	yslider->setValue( 0 );
	yslider->setTracking( FALSE );
	yslider->setTickmarks( QSlider::Above );
	yslider->setTickInterval( 1 );

	rslider = new QSlider( this, "Slider_3" );
	rslider->setGeometry( 260, 100, 120, 20 );
	rslider->setMinimumSize( 10, 10 );
	rslider->setMaximumSize( 32767, 32767 );
	connect( rslider, SIGNAL(valueChanged(int)), SLOT(rchange(int)) );
	rslider->setOrientation( QSlider::Horizontal );
	rslider->setRange( 5, 50 );
	rslider->setSteps( 5, 0 );
	rslider->setValue( 5 );
	rslider->setTracking( FALSE );
	rslider->setTickmarks( QSlider::Above );
	rslider->setTickInterval( 5 );

	QLabel* dlgedit_Label_19;
	dlgedit_Label_19 = new QLabel( this, "Label_19" );
	dlgedit_Label_19->setGeometry( 260, 20, 50, 20 );
	dlgedit_Label_19->setMinimumSize( 10, 10 );
	dlgedit_Label_19->setMaximumSize( 32767, 32767 );
	dlgedit_Label_19->setText( ktr("Hi") );
	dlgedit_Label_19->setAlignment( 289 );
	dlgedit_Label_19->setMargin( -1 );

	QLabel* dlgedit_Label_20;
	dlgedit_Label_20 = new QLabel( this, "Label_20" );
	dlgedit_Label_20->setGeometry( 330, 20, 50, 20 );
	dlgedit_Label_20->setMinimumSize( 10, 10 );
	dlgedit_Label_20->setMaximumSize( 32767, 32767 );
	dlgedit_Label_20->setText( ktr("Low") );
	dlgedit_Label_20->setAlignment( 290 );
	dlgedit_Label_20->setMargin( -1 );

	Ck_Autoload = new QCheckBox( this, "CheckBox_1" );
	Ck_Autoload->setGeometry( 15, 260, 190, 20 );
	Ck_Autoload->setMinimumSize( 10, 10 );
	Ck_Autoload->setMaximumSize( 32767, 32767 );
	Ck_Autoload->setText( ktr("Autoload driver if not detected") );
	Ck_Autoload->setAutoRepeat( FALSE );
	Ck_Autoload->setAutoResize( TRUE );

	Status = new QLabel( this, "Label_22" );
	Status->setGeometry( 10, 190, 380, 30 );
	Status->setMinimumSize( 10, 10 );
	Status->setMaximumSize( 32767, 32767 );
	Status->setFrameStyle( 49 );
	Status->setText( "Status..." );
	Status->setAlignment( 289 );
	Status->setMargin( -1 );

	resize( 395,290 );
	setMinimumSize( 395, 290 );
	setMaximumSize( 395, 290 );

	// *************************************************************
	// End Dialog
	// *************************************************************

	// Set Icona 1
	QPixmap p1( kcmjoy_xpm );
        icona1->setPixmap(p1);
	setIcon(p1);

	// Icona 2
	QPixmap p2( kcmjoy2_xpm );
        icona2->setPixmap(p2);

	// start internal timer ( 100 milli second )
	QTimer *internalTimer = new QTimer( this );
	connect( internalTimer, SIGNAL(timeout()), SLOT(Timeout()) );
	internalTimer->start( 100 );

	LoadDevices();

	if ( ( js[0] < 0 ) && ( js[1] < 0 ) && Autoload ) 
		Insmod();

	if ( ( js[0] < 0 ) && ( js[1] < 0 ) )
		Status->setText(ktr("kcmjoy - No joystick found (try Load Driver)"));
	else	{
		Status->setText("Reading...");
		dlgedit_PushButton_8->setEnabled ( FALSE );
		}
}

void Kcmjoy::Init()
{
	LoadDevices();
	if ( ( js[0] < 0 ) && ( js[1] < 0 ) && Autoload ) 
		Insmod();
}

void Kcmjoy::Insmod()
{
	if ( ( js[0] > 0 ) || ( js[1] > 0 ) )
		{
		QMessageBox::information( 0, "Kcmjoy",ktr("Driver already loaded."));
		return;
		}
	QString BufS = Pinsmod+" "+kapp->kde_datadir()+"/kcmjoy/drv/joystick.o";
	Busy=TRUE;
	if ( system(BufS) != 0 )
		{
                QMessageBox::warning( 0, "Kcmjoy",ktr("Error loading Driver !!"));
		Busy=FALSE;
		return;
		}

	LoadDevices();
	sleep(1);
	if ( !Autoload ) 
		QMessageBox::information( 0, "Kcmjoy",ktr("Driver successfully loaded."));
	Busy=FALSE;
}

void Kcmjoy::CleanupVar(bool HARD)
{
	// reset variables
	maxx=0;
	maxy=0;
	minx=9999;
	miny=9999;
	deltax=0;
	deltay=0;
	if ( HARD ) 
		{
		Curr_js=0;
		js[0]=-1;
		js[1]=-1;
		oldx=1;
		oldy=1;
		Busy=FALSE;
		}
}

Kcmjoy::~Kcmjoy()
{
	// if ( js[0] > 0 ) close(js[0]);
	// if ( js[1] > 0 ) close(js[1]);

	if (GUI)
		{
		delete(	But1 );
		delete(	But2 );
		delete(	But3 );
		delete(	But4 );
		delete(	Ck_Autoload );
		delete(	Devices );
		delete(	Display );
		delete(	Status );
		delete(	icona1 );
		delete(	icona2 );
		delete(	rslider );
		delete(	xrange );
		delete(	xslider );
		delete(	yrange );
		delete(	yslider );
		}
}

void Kcmjoy::Error(QString msg)
{
	QMessageBox::information( 0, "kcmjoy - Error:",msg);
}

void Kcmjoy::ChangeDevice(int i)
{
	Curr_js=i;
	if ( Get() ) 
		{
		xslider->setEnabled ( TRUE );
		yslider->setEnabled ( TRUE );
		rslider->setEnabled ( TRUE );
		}
	else	{
		xslider->setEnabled ( FALSE );
		yslider->setEnabled ( FALSE );
		rslider->setEnabled ( FALSE );
		xslider->setValue( 0 );
		yslider->setValue( 0 );
		rslider->setValue( 5 );
		Status->setText(ktr("kcmjoy - No joystick found (try Load Driver)"));
		}
}

void Kcmjoy::xchange(int i)
{
	if ( js[Curr_js] < 1 ) return;
        js_cal[Curr_js].x=i;
	Set();
}

void Kcmjoy::ychange(int i)
{
	if ( js[Curr_js] < 1 ) return;
        js_cal[Curr_js].y=i;
	Set();
}

void Kcmjoy::rchange(int i)
{
	if ( js[Curr_js] < 1 ) return;
        tml[Curr_js]=i;
	Set();
}

void Kcmjoy::LoadDevices()
{
	Busy=TRUE;
	if (GUI) Devices->clear();
	for ( int i = 0 ; i < 2 ; i++ )
		{
		Buf.sprintf("/dev/js%d",i);
		js[i] = open(Buf, O_RDONLY);
		if ( ( js[i] > 0 ) && ( read(js[i], &jsdata, JS_RETURN) > 0 ) && ( Get() ) )
			Buf.sprintf(ktr("Joystick %d - Found"),i+1);
		else	Buf.sprintf(ktr("Joystick %d - Not Found"),i+1);
		if (GUI) Devices->insertItem(Buf);
		}
	// Load Rc settings
	loadSettings();
	// Set new Setting
	Set();

	if (GUI)
		{
		// Update Slider
		Get();
		// Update Listbox
		Devices->setCurrentItem( 0 );
		ChangeDevice(0);
		}
	Busy=FALSE;
}

void Kcmjoy::Set()
{
	if ( js[Curr_js] < 1 ) return;

	Busy=TRUE;

	// reset variable
	CleanupVar(FALSE);

	if ( ioctl(js[Curr_js], JS_SET_TIMELIMIT, &tml[Curr_js]) )
                Error("JS_SET_TIMELIMIT ioctl failed !");

        if ( ioctl(js[Curr_js], JS_SET_TIMEOUT, &tmo[Curr_js]) )
                Error("JS_SET_TIMEOUT ioctl failed !");

        if ( ioctl(js[Curr_js], JS_SET_CAL, &js_cal[Curr_js]) )
                Error("JS_SET_CAL ioctl failed !");

	Busy=FALSE;
}

bool Kcmjoy::Get()
{
	if ( js[Curr_js] < 1 ) return(FALSE);

	Busy=TRUE;
	res =  ioctl(js[Curr_js], JS_GET_TIMELIMIT, &tml[Curr_js]);
	res =+ ioctl(js[Curr_js], JS_GET_TIMEOUT, &tmo[Curr_js]);
	res =+ ioctl(js[Curr_js], JS_GET_CAL, &js_cal[Curr_js]);

	if ( res != 0 )
		{
		Busy=FALSE;
		return(FALSE);
		}

	// reset variable
	CleanupVar(FALSE);

	xslider->setValue( js_cal[Curr_js].x );
	yslider->setValue( js_cal[Curr_js].y );
	rslider->setValue( tml[Curr_js] );

	Busy=FALSE;

	return(TRUE);
}

void Kcmjoy::Timeout()
{
	if ( ( js[Curr_js] < 1 ) || ( Busy ) ) return;
		
	if ( read(js[Curr_js], &jsdata, JS_RETURN) < 1 ) return;
	if ( jsdata.x > maxx ) maxx=jsdata.x;
	if ( jsdata.x < minx ) minx=jsdata.x;
	if ( jsdata.y > maxy ) maxy=jsdata.y;
	if ( jsdata.y < miny ) miny=jsdata.y;

	Buf.sprintf("%d - %d",maxx,minx);
	xrange->setText( Buf );
	Buf.sprintf("%d - %d",maxy,miny);
	yrange->setText( Buf );
	But1->setEnabled(!((jsdata.buttons & 0x01) >> 0));
	But2->setEnabled(!((jsdata.buttons & 0x02) >> 1));
	But3->setEnabled(!((jsdata.buttons & 0x04) >> 2));
	But4->setEnabled(!((jsdata.buttons & 0x08) >> 3));
	// We need recalibration ??
	if ( ( minx > ( maxx / 3 ) ) || ( miny > ( maxy / 3 ) ) )
		Status->setText(ktr("kcmjoy - need calibration (make a full rotation)"));
	else	Status->setText("Reading...");
	
	repaint();
}

void Kcmjoy::About()
{
	QMessageBox::about( 0, "About kcmjoy 0.1",
	"Kcmjoy 0.1\n\n"
	"(C) 1998 Luca Montecchiani (m.luca@usa.net)\n\n"
	"http://www.geocities.com/SiliconValley/Vista/2964/\n");
}

void Kcmjoy::loadSettings()
{
	// reset variable
	CleanupVar(FALSE);

	KConfig *config = kapp->getConfig();

        config->setGroup("Options");
	Autoload    = config->readNumEntry("Autoload", FALSE);
	Pinsmod     = config->readEntry("Insmod", "/sbin/insmod");
	if (GUI) Ck_Autoload->setChecked(Autoload);

        config->setGroup("js0");
        tmo[0]      = config->readNumEntry("Timeout", 4772);
        tml[0]      = config->readNumEntry("Timelimit", 10);
        js_cal[0].x = config->readNumEntry("Xfactor", 0);
        js_cal[0].y = config->readNumEntry("Yfactor", 0);

        config->setGroup("js1");
        tmo[1]      = config->readNumEntry("Timeout", 4772);
        tml[1]      = config->readNumEntry("Timelimit", 10);
        js_cal[1].x = config->readNumEntry("Xfactor", 0);
        js_cal[1].y = config->readNumEntry("Yfactor", 0);
}

void Kcmjoy::applySettings()
{
	KConfig *config = kapp->getConfig();

        config->setGroup("Options");
	config->writeEntry("Autoload", Ck_Autoload->isChecked());
	config->writeEntry("Insmod", Pinsmod);

        config->setGroup("js0");
        config->writeEntry("Timeout",tmo[0]);
        config->writeEntry("Timelimit",tml[0]);
        config->writeEntry("Xfactor",js_cal[0].x);
        config->writeEntry("Yfactor",js_cal[0].y);

        config->setGroup("js1");
        config->writeEntry("Timeout",tmo[1]);
        config->writeEntry("Timelimit",tml[1]);
        config->writeEntry("Xfactor",js_cal[1].x);
        config->writeEntry("Yfactor",js_cal[1].y);

	config->sync();
}

void Kcmjoy::paintEvent( QPaintEvent * )
{
	if ( js[Curr_js] < 0 ) return;

	deltax = (float)( maxx - minx ) / 68;
	deltay = (float)( maxy - miny ) / 68;
	if ( ( deltax == 0 ) || ( deltay == 0 ) ) return;

	QPainter p;
	p.begin( Display );

	p.setPen( white );
	p.drawLine( oldx, oldy-5, oldx, 5+oldy );
	p.drawLine( oldx-5, oldy, 5+oldx, oldy );

	p.setPen( black );
	p.drawLine( (int)((float)jsdata.x/deltax), (int)((float)jsdata.y/deltay)-5, (int)((float)jsdata.x/deltax), 5+(int)((float)jsdata.y/deltay) );
	p.drawLine( (int)((float)jsdata.x/deltax)-5, (int)((float)jsdata.y/deltay), 5+(int)((float)jsdata.x/deltax), (int)((float)jsdata.y/deltay) );

	oldx = (int)((float)jsdata.x/deltax);
	oldy = (int)((float)jsdata.y/deltay);

	p.end();
}
